/*
 *  Copyright (C) 2005-2006 mark307
 *  See Copyright Notice in COPYING.LUA
 */

#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>

#include "kmplus.h"

static const luaL_Reg kmplus_libs[] = {
	{"", luaopen_w32cd},
	{"", luaopen_w32mnu},
	{"", luaopen_w32dlg},
	{NULL, NULL}
};

__declspec(dllexport) int luaopen_kmplus(lua_State *L)
{
	const luaL_Reg *lib;
	
	for (lib = kmplus_libs; lib->func; lib ++) {
		lua_pushcfunction(L, lib->func);
		lua_pushstring(L, lib->name);
		lua_call(L, 1, 0);
	}
	return 0;
}
