#ifndef ARRAY_H
#define ARRAY_H

#if defined(__cplusplus)
extern "C" {
#endif

typedef struct {
	char *ptr;       /* data */
	size_t capacity; /* maximam length of string */
	size_t length;   /* current length of string */
} ByteArray;

extern ByteArray ByteArray_null;

void ByteArray_Initialize(ByteArray *);
void ByteArray_Finalize(ByteArray *);
int ByteArray_Resize(ByteArray *, size_t);
int ByteArray_Reserve(ByteArray *, size_t);
int ByteArray_Append(ByteArray *, char);
int ByteArray_AppendBytes(ByteArray *, const char *, size_t);
int ByteArray_Padding(ByteArray *, char , size_t);
int ByteArray_AppendPadding(ByteArray *, char, size_t);

#if defined(__cplusplus)
} /* extern "C" */
#endif

#endif /* ARRAY_H */
