#ifndef DIALOG_H
#define DIALOG_H

#if defined(__cplusplus)
extern "C" {
#endif

typedef struct _tag_DialogItem {
	WORD id;
	int (*get)(HWND, struct _tag_DialogItem *);
	int (*set)(HWND, struct _tag_DialogItem *);
	BOOL (*cmd)(HWND, int, int);
	ListType initial;
	ListType result;
} DialogItem;

typedef struct {
	ByteArray tmpl;
	ByteArray item;
	int num;
} DialogTpl;

ListType *DialogTpl_GetInitialData(DialogTpl *, WORD);
ListType *DialogTpl_GetResult(DialogTpl *, WORD);
int DialogTpl_New(DialogTpl *, DWORD, DWORD,
                  short, short, short, short, LPCTSTR,
                  LPCTSTR, WORD);
void DialogTpl_Free(DialogTpl *);
int DialogTpl_AddButton(DialogTpl *, DWORD, DWORD,
                        short, short, short, short, WORD, LPCTSTR);
int DialogTpl_AddStatic(DialogTpl *, DWORD, DWORD,
                        short, short, short, short, WORD, LPCTSTR);
int DialogTpl_AddEdit(DialogTpl *, DWORD, DWORD,
                      short, short, short, short, WORD, LPCTSTR);
int DialogTpl_AddListbox(DialogTpl *, DWORD, DWORD,
                         short, short, short, short, WORD, LPCTSTR);
int DialogTpl_AddCombobox(DialogTpl *, DWORD, DWORD,
                          short, short, short, short, WORD, LPCTSTR);
int DialogTpl_ShowModal(DialogTpl *, LPCTSTR, HANDLE, HWND);
HWND DialogTpl_Show(DialogTpl *, LPCTSTR, HANDLE, HWND);

#if defined(__cplusplus)
} /* extern "C" */
#endif

#endif /* DIALOG_H */
