#ifndef LIST_H
#define LIST_H

#if defined(__cplusplus)
extern "C" {
#endif

typedef struct tagList List;

typedef struct {
	enum {LIST, NUMBER, BUFFER} type;
	union {
		int n;
		void *b;
		List *l;
	} u;
} ListType;

struct tagList {
	ListType data;
	List *next;
};

int ListType_SetNumber(ListType *, int);
int ListType_PushNumber(ListType *, int);
int ListType_GetNumber(const ListType *, int *);

void *ListType_AllocBuffer(ListType *, size_t);
int ListType_CopyBuffer(ListType *, const void *, size_t);
void *ListType_PushAllocBuffer(ListType *, size_t);
int ListType_PushCopyBuffer(ListType *, const void *, size_t);
int ListType_GetBuffer(const ListType *, void *);

int ListType_Reverse(ListType *);

void ListType_Finalize(ListType *);

List *ListType_First(ListType *, ListType **);
List *ListType_Next(List *, ListType **);
List *List_Next(List *);

#if defined(__cplusplus)
} /* extern "C" */
#endif

#endif /* LIST_H */
