--[[

	property demo
	
	Please eval next line with eval dialog.
		require "property_demo"; property_demo()

]]

require "dialog"

local width = 120
local height = 80

local d = {
	--
	-- Button
	--
	{
		width = width,       -- width
		height = height,     -- height
		caption = "button",  -- caption
		
		-- checkbox
		-- state is w32dlg.BST_UNCHECKED or w32dlg.BST_CHECKED
		{
			type = "button",  -- control type
			style = w32dlg.BS_CHECKBOX,  -- style
			x = 5,  -- x position
			y = 5,  -- y position
			width = 40,   -- width
			height = 10,  -- height
			id = "IDCHECK1",  -- ID
			caption = "CHECK1"  -- caption
		},
		
		-- 3 state checkbox
		-- state is BST_UNCHECKED, BST_CHECKED, BST_INDETERMINATE
		{
			type = "button",  -- control type
			style = w32dlg.BS_3STATE,  -- style
			x = 5,   -- x position
			y = 20,  -- y position
			width = 40,   -- width
			height = 10,  -- height
			id = "ID3STATE",  -- ID
			caption = "3STATE"  -- caption
		},
		
		-- push like checkbox
		-- state is BST_UNCHECKED or BST_CHECKED
		{
			type = "button",  -- control type
			style = w32dlg.BS_CHECKBOX + w32dlg.BS_PUSHLIKE,
			-- style
			x = 5,   -- x position
			y = 35,  -- y position
			width = 40,   -- width
			height = 10,  -- height
			id = "IDCHECK2",  -- ID
			caption = "CHECK2"  -- caption
		},
		
		-- group box
		{
			type = "button",  -- control type
			style = w32dlg.BS_GROUPBOX,  -- style
			x = 50,  -- x position
			y = 5,   -- y position
			width = 50,   -- width
			height = 45,  -- height
			id = "IDGROUP",  -- ID
			caption = "RADIO"  -- caption
		},
		
		-- radio button
		-- grouped by w32dlg.WS_GROUP
		-- state is w32dlg.BST_UNCHECKED or w32dlg.BST_CHECKED
		{
			type = "button",  -- control type
			style = w32dlg.BS_RADIOBUTTON + w32dlg.WS_GROUP,
			-- style
			x = 55,  -- x position
			y = 15,  -- y position
			width = 40,   -- width
			height = 10,  -- height
			id = "IDRADIO1",  -- ID
			caption = "RADIO1"  -- caption
		},
		
		-- radio button
		{
			type = "button",  -- control type
			style = w32dlg.BS_RADIOBUTTON,  -- style
			x = 55,  -- x position
			y = 25,  -- y position
			width = 40,   -- width
			height = 10,  -- height
			id = "IDRADIO2",  -- ID
			caption = "RADIO2"  -- caption
		},
		-- radio button
		{
			type = "button",  -- control type
			style = w32dlg.BS_RADIOBUTTON,  -- style
			x = 55,  -- x position
			y = 35,  -- y position
			width = 40,   -- width
			height = 10,  -- height
			id = "IDRADIO3",  -- ID
			caption = "RADIO3"  -- caption
		},
	},
	--
	-- editbox
	--
	{
		width = width,     -- width
		height = height,   -- height
		caption = "edit",  -- caption
		
		-- simple
		{
			type = "edit",  -- control type
			style = w32dlg.WS_BORDER,  -- style
			x = 5,  -- x position
			y = 5,  -- y position
			width = 50,   -- width
			height = 10,  -- height
			id = "IDEDIT1",  -- ID
			caption = "EDIT"  -- caption
		},
		
		-- password
		{
			type = "edit",  -- control type
			style = w32dlg.WS_BORDER + w32dlg.ES_PASSWORD,
			-- style
			x = 5,  -- x position
			y = 20,  -- y position
			width = 50,   -- width
			height = 10,  -- height
			id = "IDEDIT2",  -- ID
			caption = "EDIT"  -- caption
		},
		
		-- number only
		{
			type = "edit",  -- control type
			style = w32dlg.WS_BORDER + w32dlg.ES_NUMBER,
			-- style
			x = 5,   -- x position
			y = 35,  -- y position
			width = 50,   -- width
			height = 10,  -- height
			id = "IDEDIT3",  -- ID
			caption = "0000"  -- caption
		},
		
		-- multiline
		{
			type = "edit",  -- control type
			style = w32dlg.WS_BORDER +
			        w32dlg.WS_VSCROLL + w32dlg.WS_HSCROLL +
			        w32dlg.ES_MULTILINE + w32dlg.ES_AUTOVSCROLL +
			        w32dlg.ES_AUTOHSCROLL + w32dlg.ES_WANTRETURN,
			-- style
			x = 70,  -- x position
			y = 5,   -- y position
			width = 55,   -- width
			height = 40,  -- height
			id = "IDEDIT4",  -- ID
			caption = "MULTILINE"  -- caption
		},
	},
	--
	-- Listbox
	--
	{
		width = width,        -- width
		height = height,      -- height
		caption = "listbox",  -- caption
		
		{
			type = "listbox",  -- control type
			style = w32dlg.WS_BORDER +
			        w32dlg.WS_VSCROLL + w32dlg.WS_HSCROLL,
			-- style
			x = 5,  -- x position
			y = 5,  -- y position
			width = 50,   -- width
			height = 40,  -- height
			id = "IDLIST1",  -- ID
		},
		
		-- Multi select
		{
			type = "listbox",  -- control type
			style = w32dlg.WS_BORDER +
			        w32dlg.WS_VSCROLL + w32dlg.WS_HSCROLL +
			        w32dlg.LBS_MULTIPLESEL,
			-- style
			x = 60,  -- x position
			y = 5,   -- y position
			width = 50,   -- width
			height = 40,  -- height
			id = "IDLIST2",  -- ID
		},
		
		-- Multi select ctrl+click or shift+drag
		-- sort
		{
			type = "listbox",  -- control type
			style = w32dlg.WS_BORDER +
			        w32dlg.WS_VSCROLL + w32dlg.WS_HSCROLL +
			        w32dlg.LBS_EXTENDEDSEL + w32dlg.LBS_SORT,
			-- style
			x = 115,  -- x position
			y = 5,    -- y position
			width = 50,   -- width
			height = 40,  -- height
			id = "IDLIST3",  -- ID
		},
	},
	-- 
	-- Combobox
	-- 
	{
		width = width,         -- width
		height = height,       -- height
		caption = "combobox",  -- caption
		
		-- simple
		-- edit and list
		{
			type = "combobox",  -- control type
			style = w32dlg.WS_BORDER +
			        w32dlg.WS_VSCROLL + w32dlg.WS_HSCROLL +
			        w32dlg.CBS_SIMPLE,
			-- style
			x = 5,  -- x position
			y = 5,  -- y position
			width = 50,   -- width
			height = 40,  -- height
			id = "IDCOMBO1",  -- ID
		},
		
		-- drop down
		-- edit and popup list
		{
			type = "combobox",  -- control type
			style = w32dlg.WS_BORDER +
			        w32dlg.WS_VSCROLL + w32dlg.WS_HSCROLL +
			        w32dlg.CBS_DROPDOWN,
			-- style
			x = 60,  -- x position
			y = 5,   -- y position
			width = 50,   -- width
			height = 40,  -- height
			id = "IDCOMBO2",  -- ID
		},
		
		-- drop down list
		-- no editable, popup list only
		{
			type = "combobox",  -- control type
			style = w32dlg.WS_BORDER +
			        w32dlg.WS_VSCROLL + w32dlg.WS_HSCROLL +
			        w32dlg.CBS_DROPDOWNLIST,
			-- style
			x = 60,  -- x position
			y = 25,  -- y position
			width = 50,   -- width
			height = 40,  -- height
			id = "IDCOMBO3",  -- ID
		},
	},
	--
	-- Static
	--
	{
		width = width,       -- width
		height = height,     -- height
		caption = "static",  -- caption
		
		-- simple
		{
			type = "static",  -- control type
			x = 5, -- x position
			y = 5, -- y position
			width = 50,   -- width
			height = 10,  -- height
			id = "IDSTATIC1",  -- ID
			caption = "static"  -- caption
		},
	}
}
local p = create_propertysheet(d)

local function print_result(r, rr)
	local k, v, k2, v2, t, l, p, i
	
	p = {"Button", "Edit", "Listbox", "Combobox",}
	l = {{"IDCHECK1", "ID3STATE", "IDCHECK2",
	      "IDRADIO1", "IDRADIO2", "IDRADIO3", },
	     {"IDEDIT1", "IDEDIT2", "IDEDIT3", "IDEDIT4", },
	     {"IDLIST1", "IDLIST2", "IDLIST3", },
	     {"IDCOMBO1", "IDCOMBO2", "IDCOMBO3", }}
	t = "Return\t:\t" .. r .. "\r\n"
	for k, v in ipairs(l) do
		t = t .. p[k] .. "\r\n"
		for k2, v2 in ipairs(v) do
			i = rr[k][v2]
			if i then
				if type(i) == "number" or
				   type(i) == "string" then
					t = t .. v2 .. " :\t" .. i .. "\r\n"
				elseif type(i) == "table" then
					t = t .. v2 .. " :\t" ..
					    table.concat(i, " ") .. "\r\n"
				end
			else
				t = t .. "\r\n" .. v2 .. "\r\n"
			end
		end
	end
	if alert then
		alert(t)
	else
		print(t)
	end
end


function property_demo()
	local r, rr, t, k, v, m
	
	m = {"January", "February", "March", "April", "May", "June",
	     "July", "August", "September", "October", "November", "December"}
	r, rr = p(nil, 0, {
			nil, -- button, initial values isn't set.
			nil, -- edit, initial values isn't set.
			{ -- listbox
				IDLIST1 = {
					{1},  -- initial selection
					m,    -- items
				},
				IDLIST2 = {nil, m},
				IDLIST3 = {nil, m},
			},
			{ -- combobox
				IDCOMBO1 = {
					nil,  -- initial string,
					      -- nil is default (empty)
					m,    -- items
				},
				IDCOMBO2 = {nil, m},
				IDCOMBO3 = {nil, m},
			},
			nil, -- static
		})
	print_result(r, rr)
	
	r, rr = p("dialog demo 2nd", 0, {
			{
				IDCHECK1 = rr[1].IDCHECK1,
				IDCHECK2 = rr[1].IDCHECK2,
				ID3STATE = rr[1].ID3STATE,
				IDRADIO1 = rr[1].IDRADIO1,
				IDRADIO2 = rr[1].IDRADIO2,
				IDRADIO3 = rr[1].IDRADIO3,
			},
			{
				IDEDIT1  = rr[2].IDEDIT1,
				IDEDIT2  = rr[2].IDEDIT2,
				IDEDIT3  = rr[2].IDEDIT3,
				IDEDIT4  = rr[2].IDEDIT4,
			},
			{
				IDLIST1 = {rr[3].IDLIST1, m},
				IDLIST2 = {rr[3].IDLIST2, m},
				IDLIST3 = {rr[3].IDLIST3, m},
			},
			{
				IDCOMBO1 = {rr[4].IDCOMBO1, m},
				IDCOMBO2 = {rr[4].IDCOMBO2, m},
				IDCOMBO3 = {rr[4].IDCOMBO3, m},
			}
	})
	
	print_result(r, rr)
end

if not km then
	property_demo()
end
