#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "array.h"

int main(int argc, char *argv[])
{
	ByteArray ba = ByteArray_null;
	
	ByteArray_Initialize(&ba);
	if (ByteArray_Append(&ba, 'a')) {
		ByteArray_Finalize(&ba);
		perror("Append");
		return 1;
	}
	if (ByteArray_AppendBytes(&ba, "bcdef", 5)) {
		ByteArray_Finalize(&ba);
		perror("AppendBytes");
		return 1;
	}
	if (ByteArray_Padding(&ba, '0', sizeof(long))) {
		ByteArray_Finalize(&ba);
		perror("Padding0");
		return 1;
	}
	if (ByteArray_Padding(&ba, '1', sizeof(long))) {
		ByteArray_Finalize(&ba);
		perror("Padding1");
		return 1;
	}
	if (ByteArray_AppendPadding(&ba, '2', sizeof(long))) {
		ByteArray_Finalize(&ba);
		perror("Padding2");
		return 1;
	}
	if (ByteArray_Append(&ba, '\0')) {
		ByteArray_Finalize(&ba);
		perror("Append");
		return 1;
	}
	if (ByteArray_Reserve(&ba, sizeof(short))) {
		ByteArray_Finalize(&ba);
		perror("Reserve");
		return 1;
	}
	printf("(long) %d, (short) %d\n%d, %d, %s\n", sizeof(long), sizeof(short),
		ba.capacity, ba.length, ba.ptr);
	ByteArray_Finalize(&ba);
	return 0;
}
