#include <windows.h>
#include <stdio.h>
#include <assert.h>

#include "array.h"
#include "list.h"
#include "dialog.h"


int main(int argc, char *argv[])
{
	DialogTpl d;
	ListType *l;
	int n, i;
	int result;
	
	result = DialogTpl_New(&d, 0, 0,
	                       0, 0, 100, 120, "dialog", NULL, 0);
	assert(! result);
	result = DialogTpl_AddButton(&d, BS_DEFPUSHBUTTON, 0,
	                             10, 10, 30, 10, IDOK, "OK");
	assert(! result);
	result = DialogTpl_AddButton(&d, BS_PUSHBUTTON | BS_FLAT, 0,
	                             50, 10, 30, 10, IDCANCEL, "Cancel");
	assert(! result);
	result = DialogTpl_AddButton(&d, BS_CHECKBOX | BS_PUSHLIKE, 0,
	                             10, 30, 30, 10, 1000, NULL);
	assert(! result);
	result = DialogTpl_AddButton(&d, BS_3STATE, 0,
	                             50, 30, 30, 10, 1001, "3state");
	assert(! result);
	result = DialogTpl_AddButton(&d, BS_GROUPBOX, 0,
	                             10, 50, 70, 30, 1002, "group");
	assert(! result);
	result = DialogTpl_AddButton(&d, BS_RADIOBUTTON | WS_GROUP, 0,
	                             20, 60, 20, 10, 1003, "1");
	assert(! result);
	result = DialogTpl_AddButton(&d, BS_RADIOBUTTON, 0,
	                             40, 60, 20, 10, 1004, "2");
	assert(! result);
	/*
	*/
	l = DialogTpl_GetInitialData(&d, 1001);
	assert(l);
	result = ListType_SetNumber(l, 1);
	assert(! result);
	l = DialogTpl_GetInitialData(&d, 1003);
	assert(l);
	result = ListType_SetNumber(l, 1);
	assert(! result);
	/* */
	result = DialogTpl_ShowModal(&d, NULL, NULL, NULL);
	printf("return code %d\n", result);
	for (i = 1000; i <= 1004; i ++) {
		printf("[%d] ", i);
		l = DialogTpl_GetResult(&d, i);
		assert(l);
		result = ListType_GetNumber(l, &n);
		assert(! result);
		printf("%d\n", n);
	}
	DialogTpl_Free(&d);
	return 0;
}
