#include <windows.h>
#include <stdio.h>
#include <assert.h>

#include "array.h"
#include "list.h"
#include "dialog.h"


int main(int argc, char *argv[])
{
	DialogTpl d;
	ListType *l;
	int n, i;
	char *ptr;
	int result;
	
	result = DialogTpl_New(&d, WS_SYSMENU, 0,
	                       0, 0, 100, 120, "dialog", NULL, 0);
	assert(! result);
	result = DialogTpl_AddButton(&d, BS_DEFPUSHBUTTON, 0,
	                             10, 10, 30, 10, IDOK, "OK");
	assert(! result);
	result = DialogTpl_AddCombobox(&d,
		CBS_SIMPLE | WS_VSCROLL | WS_HSCROLL,
		0, 10, 30, 80, 30, 1000, "0");
	assert(! result);
	result = DialogTpl_AddCombobox(&d,
		CBS_DROPDOWN | CBS_AUTOHSCROLL | WS_BORDER | WS_VSCROLL,
		0, 10, 70, 30, 40, 1001, "1");
	assert(! result);
	result = DialogTpl_AddCombobox(&d,
		CBS_DROPDOWNLIST | CBS_SORT | WS_BORDER | WS_VSCROLL,
		0, 50, 70, 30, 40, 1002, "2");
	assert(! result);
	/*
	*/
	for (i = 1000; i <= 1002; i ++) {
		l = DialogTpl_GetInitialData(&d, i);
		assert(l);
#define ITEM(x) (x), sizeof(x)
		result = ListType_PushCopyBuffer(l, ITEM("a"));
		assert(! result);
		result = ListType_PushCopyBuffer(l, ITEM("b"));
		assert(! result);
		result = ListType_PushCopyBuffer(l, ITEM("c"));
		assert(! result);
		result = ListType_PushCopyBuffer(l, ITEM("d"));
		assert(! result);
		result = ListType_PushCopyBuffer(l, ITEM("e"));
		assert(! result);
		switch (i) {
		case 1000:
			result = ListType_PushCopyBuffer(l, ITEM("1000"));
			break;
		case 1001:
			result = ListType_PushCopyBuffer(l, ITEM("b"));
			break;
		case 1002:
			result = ListType_PushCopyBuffer(l, ITEM("b"));
			break;
		}
		assert(! result);
	}
	/* */
	result = DialogTpl_ShowModal(&d, "combobox test", NULL, NULL);
	printf("return code %d\n", result);
	for (i = 1000; i <= 1002; i ++) {
		printf("[%d] ", i);
		l = DialogTpl_GetResult(&d, i);
		assert(l);
		ptr = NULL;
		result = ListType_GetBuffer(l, &ptr);
		assert(! result);
		printf("%s\n", ptr);
	}
	DialogTpl_Free(&d);
	return 0;
}
