#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "list.h"

void ListType_dump(ListType *t)
{
	List *l;
	
	if (t) {
		switch (t->type) {
		case NUMBER:
			printf("n: %d\n", t->u.n);
			break;
		case BUFFER:
			printf("b: %s\n", (char *) t->u.b);
			break;
		case LIST:
			printf("l: {\n");
			l = t->u.l;
			while (l) {
				ListType_dump(&l->data);
				l = List_Next(l);
			}
			printf("}\n");
			break;
		}
	}
}

void ListType_dumplist(ListType *t)
{
	List *l;
	ListType *p;
	
	if (t) {
		puts("ListType_dumplist {");
		l = ListType_First(t, &p);
		while (p) {
			ListType_dump(p);
			l = ListType_Next(l, &p);
		}
		puts("}");
	}
}

int main(int argc, char *argv[])
{
	ListType list = {0};

#define ITEM(x) (#x), sizeof(#x)

	printf("%d ", ListType_SetNumber(&list, 128));
	ListType_dumplist(&list);
	printf("%d ", ListType_CopyBuffer(&list, ITEM(abcdef)));
	ListType_dumplist(&list);
	printf("%d ", ListType_PushCopyBuffer(&list, ITEM(123456)));
	ListType_dumplist(&list);
	printf("%d ", ListType_PushNumber(&list, 821));
	ListType_dumplist(&list);
	printf("%d ", ListType_Reverse(&list));
	ListType_dumplist(&list);
	ListType_Finalize(&list);
	ListType_dumplist(&list);
	printf("%d ", ListType_PushCopyBuffer(&list, ITEM(123456)));
	ListType_dumplist(&list);
	printf("%d ", ListType_Reverse(&list));
	ListType_dumplist(&list);
	printf("%d ", ListType_PushNumber(&list, 789));
	ListType_dumplist(&list);
	printf("%d ", ListType_SetNumber(&list, 0));
	ListType_dumplist(&list);
	ListType_Finalize(&list);
	ListType_dumplist(&list);
	return 0;
}
