#include <windows.h>
#include <stdio.h>
#include <assert.h>

#include "array.h"
#include "list.h"
#include "dialog.h"


int main(int argc, char *argv[])
{
	DialogTpl d;
	ListType *l;
	int n, *np, i;
	int result;
	int sel[] = {1, 2, -1};
	
	result = DialogTpl_New(&d, 0, 0,
	                       0, 0, 100, 120, "dialog", NULL, 0);
	assert(! result);
	result = DialogTpl_AddButton(&d, BS_DEFPUSHBUTTON, 0,
	                             10, 10, 30, 10, IDOK, "OK");
	assert(! result);
	result = DialogTpl_AddListbox(&d,
		LBS_NOTIFY | LBS_SORT | LBS_USETABSTOPS | 
		LBS_MULTICOLUMN | WS_VSCROLL | WS_HSCROLL,
		WS_EX_CLIENTEDGE, 10, 30, 80, 30, 1000, "OK");
	assert(! result);
	result = DialogTpl_AddListbox(&d,
		LBS_MULTIPLESEL | WS_BORDER | WS_VSCROLL,
		0, 10, 70, 80, 40, 1001, "Cancel");
	assert(! result);
	/*
	*/
	l = DialogTpl_GetInitialData(&d, 1000);
	assert(l);
#define ITEM(x) (x), sizeof(x)
	result = ListType_PushCopyBuffer(l, ITEM("a\t1"));
	assert(! result);
	result = ListType_PushCopyBuffer(l, ITEM("b\t2"));
	assert(! result);
	result = ListType_PushCopyBuffer(l, ITEM("c\t3"));
	assert(! result);
	result = ListType_PushCopyBuffer(l, ITEM("d\t4"));
	assert(! result);
	result = ListType_PushCopyBuffer(l, ITEM("e\t5"));
	assert(! result);
	result = ListType_PushNumber(l, 1);
	assert(! result);
//	result = ListType_Reverse(l);
//	assert(! result);
	/* */
	l = DialogTpl_GetInitialData(&d, 1001);
	assert(l);
	result = ListType_PushCopyBuffer(l, ITEM("a\t1"));
	assert(! result);
	result = ListType_PushCopyBuffer(l, ITEM("b\t2"));
	assert(! result);
	result = ListType_PushCopyBuffer(l, ITEM("c\t3"));
	assert(! result);
	result = ListType_PushCopyBuffer(l, ITEM("d\t4"));
	assert(! result);
	result = ListType_PushCopyBuffer(l, ITEM("e\t5"));
	assert(! result);
	result = ListType_PushCopyBuffer(l, sel, sizeof(sel));
	assert(! result);
	/* */
	result = DialogTpl_ShowModal(&d, "listbox test", NULL, NULL);
	printf("return code %d\n", result);
	for (i = 1000; i <= 1001; i ++) {
		printf("[%d] ", i);
		l = DialogTpl_GetResult(&d, i);
		assert(l);
		switch (l->type) {
		case NUMBER:
			result = ListType_GetNumber(l, &n);
			assert(! result);
			printf("%d\n", n);
			break;
		case BUFFER:
			result = ListType_GetBuffer(l, &np);
			assert(! result);
			for (; *np >= 0; np ++) {
				printf("%d ", *np);
			}
			putchar('\n');
			break;
		}
	}
	DialogTpl_Free(&d);
	return 0;
}
