-- Undo closed tab
-- for tab version only

-- Install
-- Put this on lua folder and add `require "undo"' to macros.lua.

require "compat"
require "hook"
require "setmenu" -- needs setmenu.modify
local max = km.getpref(TYPE_INT, "kmeleon.maximum.undo")
if max < 1 then max = 1; end
local data = {}
local function undo_menu(m)
	local h,i={}
	for i=1, #data do
		h[i]={data[i].title, "luamacros(undo("..i.."))"}
	end
	if m then
		setmenu.modify("&Edit", 0, "Undo Closed Tabs...", h)
	else
		setmenu.append("&Edit", 0, "Undo Closed Tabs...", h)
	end
end
hook.add(StartupHook, undo_menu)
local function OnCloseTab()
	local title, url = GetDocInfo()
	while #data >= max do
		table.remove(data)
	end
	table.insert(data, 1, {url = url, title = title})
	undo_menu(true)
end
hook.add(CloseTabHook, OnCloseTab)
function undo(arg)
	local n = tonumber(arg)
	if data[n] then
		opennew(data[n].url)
	end
end
